
/*  A Bison parser, made from /home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	INDVAR	258
#define	SEQVAR	259
#define	CONSTANT	260
#define	CONSIS	261
#define	AND	262
#define	NOT	263
#define	OR	264
#define	FORALL	265
#define	EXISTS	266
#define	STRING	267
#define	NUMBER	268
#define	FALSE	269
#define	TRUE	270
#define	EQ	271
#define	NOTEQ	272
#define	IMPLIES	273
#define	IMPLIED	274
#define	EQUIV	275
#define	RULELR	276
#define	RULERL	277
#define	IF	278
#define	LISTOF	279
#define	SETOF	280
#define	QUOTE	281
#define	QUOTESYM	282
#define	COND	283
#define	THE	284
#define	SETOFALL	285
#define	KAPPA	286
#define	LAMBDA	287
#define	DEFOBJECT	288
#define	DEFFUNCTION	289
#define	DEFRELATION	290
#define	COLEQ	291
#define	COLEQLT	292
#define	COLAMP	293

#line 1 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"

// Author : Gregory R. Olsen 
//          Center for Design Research, Stanford University
//          560 Panama Street
//          Stanford, CA 94305-2232
//          olsen@cs.stanford.edu
// Contributions by: Jim McGuire (Lockheed AI Center)

// Copyright (c) 1993 Stanford University. All rights reserved.
// Copyright (c) 1993 Lockheed Missiles and Space Co.

/*
 * Permission is hereby granted, without written agreement and without
 * license, to use, copy, modify, and distribute this software and its 
 * documentation for non-commercial use, provided that the above 
 * copyright notice and the following two paragraphs appear in
 * all copies of this software.
 * 
 * THIS SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * IN NO EVENT SHALL STANFORD UNIVERSITY OR LOCKHEED MISSILES AND SPACE 
 * COMPANY BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT OR 
 * CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED
 * OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING 
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include <stdlib.h>
#include <ctype.h> 
#include "KIFClass.h"
#define YYDEBUG 1
extern int yylex(void);
void yyerror(char *s);
expression *kif_result;


#line 40 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
typedef union {
  char *val;
  sentence *sen; 
  term *ter;
  definition *def;
  form *frm;
  expression *exp;
  sequence *seq;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		202
#define	YYFLAG		-32768
#define	YYNTBASE	41

#define YYTRANSLATE(x) ((unsigned)(x) <= 293 ? yytranslate[x] : 71)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     8,
     7,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39,    40
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,     8,    10,    16,    22,    24,    27,
    29,    34,    36,    38,    45,    55,    65,    70,    78,    86,
    88,    91,    93,    95,    97,    99,   101,   103,   109,   115,
   120,   125,   130,   136,   142,   148,   154,   162,   168,   176,
   181,   185,   190,   192,   194,   197,   200,   202,   204,   206,
   208,   210,   212,   214,   216,   218,   220,   225,   229,   233,
   238,   242,   247,   252,   257,   262,   267,   272,   278,   285,
   287,   290,   292,   294,   300,   302,   304,   307,   311,   313,
   315,   317,   319,   321,   323,   326,   328,   330,   332,   334,
   336,   338,   340,   342,   344,   346,   348,   350,   352,   354,
   356,   358,   360,   362,   364,   366,   368,   370,   372,   374,
   376,   378,   380,   382,   384,   386,   388
};

static const short yyrhs[] = {    42,
     0,     1,     0,    50,     0,    46,     0,    43,     0,     8,
    23,    44,    50,     7,     0,     8,    24,    50,    44,     7,
     0,    45,     0,    44,    45,     0,    50,     0,     8,     6,
    50,     7,     0,    47,     0,    48,     0,     8,    35,     5,
    38,    57,     7,     0,     8,    36,     5,     8,    63,     7,
    38,    57,     7,     0,     8,    37,     5,     8,    63,     7,
    38,    50,     7,     0,     8,    35,     5,     7,     0,     8,
    36,     5,     8,    63,     7,     7,     0,     8,    37,     5,
     8,    63,     7,     7,     0,    50,     0,    49,    50,     0,
    51,     0,    52,     0,    53,     0,    54,     0,    64,     0,
    55,     0,     8,    18,    57,    57,     7,     0,     8,    19,
    57,    57,     7,     0,     8,    10,    50,     7,     0,     8,
     9,    49,     7,     0,     8,    11,    49,     7,     0,     8,
    20,    49,    50,     7,     0,     8,    21,    50,    49,     7,
     0,     8,    22,    50,    50,     7,     0,     8,    12,     3,
    50,     7,     0,     8,    12,     8,    63,     7,    50,     7,
     0,     8,    13,     3,    50,     7,     0,     8,    13,     8,
    63,     7,    50,     7,     0,     8,     5,    56,     7,     0,
     8,     5,     7,     0,     8,    17,    56,     7,     0,     4,
     0,    57,     0,    56,     4,     0,    56,    57,     0,     3,
     0,     5,     0,    14,     0,    15,     0,    58,     0,    59,
     0,    60,     0,    62,     0,    61,     0,    65,     0,     8,
     5,    56,     7,     0,     8,     5,     7,     0,     8,    26,
     7,     0,     8,    26,    56,     7,     0,     8,    27,     7,
     0,     8,    27,    56,     7,     0,     8,    28,    57,     7,
     0,     8,    28,    50,     7,     0,     8,    28,    43,     7,
     0,     8,    28,    66,     7,     0,     8,    28,    46,     7,
     0,     8,    25,    50,    57,     7,     0,     8,    25,    50,
    57,    57,     7,     0,     3,     0,    63,     3,     0,    17,
     0,    16,     0,     8,    32,    57,    50,     7,     0,     0,
     0,     0,     0,     8,     7,     0,     8,     0,     7,     0,
     5,     0,     3,     0,    14,     0,    15,     0,    66,     0,
     0,     0,     0,     0,     0,    68,     0,    69,     0,    70,
     0,    67,     0,    35,     0,    36,     0,    37,     0,    38,
     0,    39,     0,    40,     0,    26,     0,    27,     0,    28,
     0,    29,     0,    25,     0,    30,     0,    32,     0,    33,
     0,    34,     0,    18,     0,    19,     0,    10,     0,     9,
     0,    11,     0,    20,     0,    21,     0,    22,     0,    12,
     0,    13,     0,    23,     0,    24,     0,     6,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    71,    72,    74,    75,    76,    78,    80,    83,    85,    88,
    90,    93,    94,    96,    99,   102,   106,   109,   112,   116,
   117,   119,   120,   121,   122,   123,   124,   126,   129,   132,
   134,   136,   138,   140,   142,   145,   149,   151,   155,   158,
   161,   164,   168,   171,   173,   176,   179,   180,   181,   182,
   183,   184,   185,   186,   187,   188,   190,   193,   197,   199,
   202,   204,   207,   209,   211,   213,   215,   218,   220,   223,
   226,   230,   231,   233,   236,   237,   239,   240,   244,   245,
   246,   247,   248,   250,   251,   253,   254,   255,   256,   258,
   259,   260,   261,   262,   263,   265,   266,   267,   268,   269,
   270,   271,   272,   273,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   287,   288,   289
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","INDVAR",
"SEQVAR","CONSTANT","CONSIS","')'","'('","AND","NOT","OR","FORALL","EXISTS",
"STRING","NUMBER","FALSE","TRUE","EQ","NOTEQ","IMPLIES","IMPLIED","EQUIV","RULELR",
"RULERL","IF","LISTOF","SETOF","QUOTE","QUOTESYM","COND","THE","SETOFALL","KAPPA",
"LAMBDA","DEFOBJECT","DEFFUNCTION","DEFRELATION","COLEQ","COLEQLT","COLAMP",
"kifexp","form","rule","premiseseq","premise","definition","complete","partial",
"sentenceseq","sentence","equation","inequality","logsent","quantsent","relsent",
"termseq","term","functerm","listterm","setterm","quoterm","logterm","indvarseq",
"logconst","quanterm","operator","defop","termop","sentop","ruleop", NULL
};
#endif

static const short yyr1[] = {     0,
    41,    41,    42,    42,    42,    43,    43,    44,    44,    45,
    45,    46,    46,    47,    47,    47,    48,    48,    48,    49,
    49,    50,    50,    50,    50,    50,    50,    51,    52,    53,
    53,    53,    53,    53,    53,    54,    54,    54,    54,    55,
    55,    55,    56,    56,    56,    56,    57,    57,    57,    57,
    57,    57,    57,    57,    57,    57,    58,    58,    59,    59,
    60,    60,    61,    61,    61,    61,    61,    62,    62,    63,
    63,    64,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    66,    66,    66,    66,    67,
    67,    67,    67,    67,    67,    68,    68,    68,    68,    68,
    68,    68,    68,    68,    69,    69,    69,    69,    69,    69,
    69,    69,    69,    69,    70,    70,    70
};

static const short yyr2[] = {     0,
     1,     1,     1,     1,     1,     5,     5,     1,     2,     1,
     4,     1,     1,     6,     9,     9,     4,     7,     7,     1,
     2,     1,     1,     1,     1,     1,     1,     5,     5,     4,
     4,     4,     5,     5,     5,     5,     7,     5,     7,     4,
     3,     4,     1,     1,     2,     2,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     4,     3,     3,     4,
     3,     4,     4,     4,     4,     4,     4,     5,     6,     1,
     2,     1,     1,     5,     1,     1,     2,     3,     1,     1,
     1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1
};

static const short yydefact[] = {     0,
     2,     0,    73,    72,     1,     5,     4,    12,    13,     3,
    22,    23,    24,    25,    27,    26,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    47,    43,    48,    41,     0,    49,    50,
     0,    44,    51,    52,    53,    55,    54,    56,     0,     0,
    20,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     8,    10,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    45,    40,    46,
    31,    21,    30,    32,     0,    70,     0,     0,     0,    42,
     0,     0,    21,     0,     0,     0,     9,    10,     0,    17,
     0,     0,     0,    58,     0,     0,    59,     0,    61,     0,
   117,     0,   108,   107,   109,   113,   114,   105,   106,   110,
   111,   112,   115,   116,   100,    96,    97,    98,    99,   101,
   102,   103,   104,    90,    91,    92,    93,    94,    95,     0,
     0,     0,     0,     0,    89,    86,    87,    88,     0,    36,
    71,     0,    38,     0,    28,    29,    33,    34,    35,     0,
     6,     7,     0,     0,     0,    57,     0,    60,    62,     0,
    65,    67,    64,    63,    66,     0,     0,     0,    11,    14,
     0,     0,    68,     0,    41,     0,    74,    37,    39,    18,
     0,    19,     0,    69,    40,     0,     0,    15,    16,     0,
     0,     0
};

static const short yydefgoto[] = {   200,
     5,     6,    65,    66,     7,     8,     9,    50,    51,    11,
    12,    13,    14,    15,    41,    42,    43,    44,    45,    46,
    47,    87,    16,    48,   144,   145,   146,   147,   148
};

static const short yypact[] = {     8,
-32768,   193,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   156,    43,    43,    43,
    10,    28,    66,    18,    18,    43,    43,    43,   125,    43,
     2,    12,    15,-32768,-32768,-32768,-32768,   118,-32768,-32768,
   252,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   232,    76,
-32768,    48,   149,    43,    59,    43,    59,   265,    18,    18,
    43,    43,    43,   214,   125,-32768,-32768,   125,    -3,    64,
    67,   278,    43,   291,   304,    92,    18,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    70,-32768,     7,    71,    31,-32768,
    72,    78,    81,   231,    83,    43,-32768,   127,   384,-32768,
    18,    59,    59,-32768,   317,    18,-32768,   330,-32768,   343,
-32768,   164,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   128,
   129,   130,   131,   132,-32768,-32768,-32768,-32768,    43,-32768,
-32768,    43,-32768,    43,-32768,-32768,-32768,-32768,-32768,   133,
-32768,-32768,   140,    42,    45,-32768,   382,-32768,-32768,   356,
-32768,-32768,-32768,-32768,-32768,   144,   146,   148,-32768,-32768,
     4,     5,-32768,   151,-32768,   369,-32768,-32768,-32768,-32768,
    18,-32768,    43,-32768,-32768,   161,   171,-32768,-32768,   179,
   180,-32768
};

static const short yypgoto[] = {-32768,
-32768,   119,   126,   -62,   121,-32768,-32768,   -18,     0,-32768,
-32768,-32768,-32768,-32768,    -8,   -19,-32768,-32768,-32768,-32768,
-32768,   -56,-32768,-32768,-32768,-32768,-32768,-32768,-32768
};


#define	YYLAST		401


static const short yytable[] = {    10,
    89,    53,    97,   100,    59,    60,    69,    61,     1,   151,
   190,   192,    54,   152,    58,     2,    70,    55,    52,    71,
    34,    80,    36,     3,     4,    38,    62,    63,    67,    68,
    56,    39,    40,   151,   101,    57,    97,   154,    80,    91,
    92,   191,   193,    94,   151,   164,   165,   151,   181,    82,
    49,   182,    82,    85,    83,    88,   143,   149,     3,     4,
    93,    86,    95,   105,    98,   108,   110,    67,    34,    35,
    36,   102,   106,    38,   103,   142,   150,   153,   155,    39,
    40,   163,    81,    49,   156,    80,   167,   157,    80,   159,
    80,     3,     4,    82,    34,   160,    36,   111,    67,   112,
   113,   114,   115,   116,   117,    39,    40,     3,     4,   118,
   119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
   129,   130,    72,   131,   132,   133,   134,   135,   136,   137,
   138,   139,    64,   161,   171,   172,   173,   174,   175,   179,
     3,     4,    73,    74,    75,    76,   180,   184,   176,    77,
   187,   177,   188,   178,   189,    84,    49,   194,    34,    35,
    36,   186,    37,    38,     3,     4,    80,   198,   170,    39,
    40,   196,    18,    19,    20,    21,    22,   199,   201,   202,
    23,    24,    25,    26,    27,    28,    29,    30,    73,    74,
    75,    76,   197,    99,   140,    77,   141,    17,    31,    32,
    33,    18,    19,    20,    21,    22,     0,     0,     0,    23,
    24,    25,    26,    27,    28,    29,    30,     0,    17,    96,
     0,     0,    18,    19,    20,    21,    22,    31,    32,    33,
    23,    24,    25,    26,    27,    28,    17,   158,    49,     0,
    18,    19,    20,    21,    22,     0,     3,     4,    23,    24,
    25,    26,    27,    28,    34,    78,    36,     0,    79,    38,
     0,     0,     0,     0,     0,    39,    40,    34,    78,    36,
     0,    90,    38,     0,     0,     0,     0,     0,    39,    40,
    34,    35,    36,     0,   104,    38,     0,     0,     0,     0,
     0,    39,    40,    34,    35,    36,     0,   107,    38,     0,
     0,     0,     0,     0,    39,    40,    34,    35,    36,     0,
   109,    38,     0,     0,     0,     0,     0,    39,    40,    34,
    78,    36,     0,   166,    38,     0,     0,     0,     0,     0,
    39,    40,    34,    78,    36,     0,   168,    38,     0,     0,
     0,     0,     0,    39,    40,    34,    78,    36,     0,   169,
    38,     0,     0,     0,     0,     0,    39,    40,    34,    35,
    36,     0,   185,    38,     0,     0,     0,     0,     0,    39,
    40,    34,    78,    36,     0,   195,    38,     0,     0,     0,
     0,     0,    39,    40,    34,     0,    36,     0,   183,    38,
   162,    64,     0,     0,     0,    39,    40,     0,     0,     3,
     4
};

static const short yycheck[] = {     0,
    57,    20,    65,     7,    24,    25,     5,    26,     1,     3,
     7,     7,     3,     7,    23,     8,     5,     8,    19,     5,
     3,    41,     5,    16,    17,     8,    27,    28,    29,    30,
     3,    14,    15,     3,    38,     8,    99,     7,    58,    59,
    60,    38,    38,    62,     3,   102,   103,     3,     7,    50,
     8,     7,    53,    54,     7,    56,    76,    77,    16,    17,
    61,     3,    63,    72,    65,    74,    75,    68,     3,     4,
     5,     8,    73,     8,     8,    76,     7,     7,     7,    14,
    15,   101,     7,     8,     7,   105,   106,     7,   108,     7,
   110,    16,    17,    94,     3,    96,     5,     6,    99,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,     5,    32,    33,    34,    35,    36,    37,    38,
    39,    40,     8,     7,     7,     7,     7,     7,     7,     7,
    16,    17,    25,    26,    27,    28,     7,   167,   149,    32,
     7,   152,     7,   154,     7,     7,     8,     7,     3,     4,
     5,   170,     7,     8,    16,    17,   186,     7,     5,    14,
    15,   191,     9,    10,    11,    12,    13,     7,     0,     0,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,   193,    68,    76,    32,    76,     5,    35,    36,
    37,     9,    10,    11,    12,    13,    -1,    -1,    -1,    17,
    18,    19,    20,    21,    22,    23,    24,    -1,     5,     6,
    -1,    -1,     9,    10,    11,    12,    13,    35,    36,    37,
    17,    18,    19,    20,    21,    22,     5,     7,     8,    -1,
     9,    10,    11,    12,    13,    -1,    16,    17,    17,    18,
    19,    20,    21,    22,     3,     4,     5,    -1,     7,     8,
    -1,    -1,    -1,    -1,    -1,    14,    15,     3,     4,     5,
    -1,     7,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,
     3,     4,     5,    -1,     7,     8,    -1,    -1,    -1,    -1,
    -1,    14,    15,     3,     4,     5,    -1,     7,     8,    -1,
    -1,    -1,    -1,    -1,    14,    15,     3,     4,     5,    -1,
     7,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,     3,
     4,     5,    -1,     7,     8,    -1,    -1,    -1,    -1,    -1,
    14,    15,     3,     4,     5,    -1,     7,     8,    -1,    -1,
    -1,    -1,    -1,    14,    15,     3,     4,     5,    -1,     7,
     8,    -1,    -1,    -1,    -1,    -1,    14,    15,     3,     4,
     5,    -1,     7,     8,    -1,    -1,    -1,    -1,    -1,    14,
    15,     3,     4,     5,    -1,     7,     8,    -1,    -1,    -1,
    -1,    -1,    14,    15,     3,    -1,     5,    -1,     7,     8,
     7,     8,    -1,    -1,    -1,    14,    15,    -1,    -1,    16,
    17
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 71 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{kif_result = yyvsp[0].frm;YYACCEPT;;
    break;}
case 2:
#line 72 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{kif_result = NULL;yyclearin;YYACCEPT;;
    break;}
case 3:
#line 74 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.frm=yyvsp[0].sen;;
    break;}
case 4:
#line 75 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.frm=yyvsp[0].def;;
    break;}
case 5:
#line 76 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.frm=yyvsp[0].frm;;
    break;}
case 6:
#line 79 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.frm=new rule(yyvsp[-2].seq,yyvsp[-1].sen);;
    break;}
case 7:
#line 81 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.frm=new rule(yyvsp[-1].seq,yyvsp[-2].sen);;
    break;}
case 8:
#line 84 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.seq=new sequence(yyvsp[0].exp);;
    break;}
case 9:
#line 86 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyvsp[-1].seq->add(yyvsp[0].exp);yyval.seq=yyvsp[-1].seq;;
    break;}
case 10:
#line 89 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp=yyvsp[0].sen;;
    break;}
case 11:
#line 91 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp=new consis(yyvsp[-1].sen);;
    break;}
case 12:
#line 93 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.def = yyvsp[0].def;;
    break;}
case 13:
#line 94 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.def = yyvsp[0].def;;
    break;}
case 14:
#line 97 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{objconst *o=new objconst(yyvsp[-3].val); 
		 yyval.def=new objectdef(o,yyvsp[-1].ter);;
    break;}
case 15:
#line 100 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{funconst *f=new funconst(yyvsp[-6].val); 
		 yyval.def=new functiondef(f,yyvsp[-4].seq,yyvsp[-1].ter);;
    break;}
case 16:
#line 103 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{relconst *r=new relconst(yyvsp[-6].val); 
		 yyval.def=new relationdef(r,yyvsp[-4].seq,yyvsp[-1].sen);;
    break;}
case 17:
#line 107 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{objconst *o=new objconst(yyvsp[-1].val); 
		 yyval.def=new objectdef(o,(term *) kifobj::nullmarker);;
    break;}
case 18:
#line 110 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{funconst *f=new funconst(yyvsp[-4].val); 
		 yyval.def=new functiondef(f,yyvsp[-2].seq,(term *) kifobj::nullmarker);;
    break;}
case 19:
#line 113 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{relconst *r=new relconst(yyvsp[-4].val); 
		 yyval.def=new relationdef(r,yyvsp[-2].seq,(sentence *) kifobj::nullmarker);;
    break;}
case 20:
#line 116 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.seq=new sequence(yyvsp[0].sen);;
    break;}
case 21:
#line 117 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyvsp[-1].seq->add(yyvsp[0].sen);yyval.seq=yyvsp[-1].seq;;
    break;}
case 22:
#line 119 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=yyvsp[0].sen;;
    break;}
case 23:
#line 120 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=yyvsp[0].sen;;
    break;}
case 24:
#line 121 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=yyvsp[0].sen;;
    break;}
case 25:
#line 122 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=yyvsp[0].sen;;
    break;}
case 26:
#line 123 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=yyvsp[0].sen;;
    break;}
case 27:
#line 124 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=yyvsp[0].sen;;
    break;}
case 28:
#line 127 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new equation(yyvsp[-2].ter,yyvsp[-1].ter);;
    break;}
case 29:
#line 130 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new inequality(yyvsp[-2].ter,yyvsp[-1].ter);;
    break;}
case 30:
#line 133 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new negation(yyvsp[-1].sen);;
    break;}
case 31:
#line 135 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new conjunction(yyvsp[-1].seq);;
    break;}
case 32:
#line 137 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new disjunction(yyvsp[-1].seq);;
    break;}
case 33:
#line 139 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new implication(yyvsp[-2].seq,yyvsp[-1].sen);;
    break;}
case 34:
#line 141 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new implication(yyvsp[-1].seq,yyvsp[-2].sen);;
    break;}
case 35:
#line 143 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new equivalence(yyvsp[-2].sen,yyvsp[-1].sen);;
    break;}
case 36:
#line 146 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{indvar *iv=new indvar(yyvsp[-2].val);
			 sequence *t=new sequence(iv);
			 yyval.sen=new universent(t,yyvsp[-1].sen);;
    break;}
case 37:
#line 150 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new universent(yyvsp[-3].seq,yyvsp[-1].sen);;
    break;}
case 38:
#line 152 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{indvar *iv=new indvar(yyvsp[-2].val); 
			 sequence *t=new sequence(iv);
			 yyval.sen=new existensent(t,yyvsp[-1].sen);;
    break;}
case 39:
#line 156 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen=new existensent(yyvsp[-3].seq,yyvsp[-1].sen);;
    break;}
case 40:
#line 159 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{relconst *rel=new relconst(yyvsp[-2].val); 
		 yyval.sen=new relsent(rel,yyvsp[-1].seq);;
    break;}
case 41:
#line 162 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{relconst *rel=new relconst(yyvsp[-1].val); 
		 yyval.sen=new relsent(rel,(sequence *) kifobj::nullmarker);;
    break;}
case 42:
#line 165 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{relconst *rel=new relconst(yyvsp[-2].val); 
                 yyval.sen=new relsent(rel,yyvsp[-1].seq);;
    break;}
case 43:
#line 169 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{seqvar *e = new seqvar(yyvsp[0].val); 
		 yyval.seq=new sequence(e);;
    break;}
case 44:
#line 172 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.seq=new sequence(yyvsp[0].ter);;
    break;}
case 45:
#line 174 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{seqvar *e = new seqvar(yyvsp[0].val); 
		 yyvsp[-1].seq->add(e); yyval.seq=yyvsp[-1].seq;;
    break;}
case 46:
#line 177 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyvsp[-1].seq->add(yyvsp[0].ter); yyval.seq=yyvsp[-1].seq;;
    break;}
case 47:
#line 179 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new indvar(yyvsp[0].val);;
    break;}
case 48:
#line 180 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new objconst(yyvsp[0].val);;
    break;}
case 49:
#line 181 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new string(yyvsp[0].val);;
    break;}
case 50:
#line 182 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new number(yyvsp[0].val);;
    break;}
case 51:
#line 183 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = yyvsp[0].ter;;
    break;}
case 52:
#line 184 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = yyvsp[0].ter;;
    break;}
case 53:
#line 185 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = yyvsp[0].ter;;
    break;}
case 54:
#line 186 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = yyvsp[0].ter;;
    break;}
case 55:
#line 187 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = yyvsp[0].ter;;
    break;}
case 56:
#line 188 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = yyvsp[0].ter;;
    break;}
case 57:
#line 191 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{funconst *c=new funconst(yyvsp[-2].val);
			 yyval.ter = new functerm(c,yyvsp[-1].seq);;
    break;}
case 58:
#line 194 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{funconst *c=new funconst(yyvsp[-1].val);
			 yyval.ter = new functerm(c,(sequence *) kifobj::nullmarker);;
    break;}
case 59:
#line 198 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new listterm((sequence *) kifobj::nullmarker);;
    break;}
case 60:
#line 200 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new listterm(yyvsp[-1].seq);;
    break;}
case 61:
#line 203 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new setterm((sequence *) kifobj::nullmarker);;
    break;}
case 62:
#line 205 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new setterm(yyvsp[-1].seq);;
    break;}
case 63:
#line 208 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new quoterm(yyvsp[-1].ter);;
    break;}
case 64:
#line 210 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new quoterm(yyvsp[-1].sen);;
    break;}
case 65:
#line 212 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new quoterm(yyvsp[-1].frm);;
    break;}
case 66:
#line 214 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new quoterm(yyvsp[-1].exp);;
    break;}
case 67:
#line 216 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new quoterm(yyvsp[-1].def);;
    break;}
case 68:
#line 219 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new ifterm(yyvsp[-2].sen,yyvsp[-1].ter,(term *) kifobj::nullmarker);;
    break;}
case 69:
#line 221 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new ifterm(yyvsp[-3].sen,yyvsp[-2].ter,yyvsp[-1].ter);;
    break;}
case 70:
#line 224 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{indvar *iv=new indvar(yyvsp[0].val);
			 yyval.seq=new sequence(iv);;
    break;}
case 71:
#line 227 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{indvar *iv=new indvar(yyvsp[0].val);
                         yyvsp[-1].seq->add(iv);yyval.seq=yyvsp[-1].seq;;
    break;}
case 72:
#line 230 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen = new logconst((unsigned) 1);;
    break;}
case 73:
#line 231 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.sen = new logconst((unsigned) 0);;
    break;}
case 74:
#line 234 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.ter = new setofallterm(yyvsp[-2].ter,yyvsp[-1].sen);;
    break;}
case 75:
#line 236 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = yyvsp[0].exp;;
    break;}
case 76:
#line 237 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = yyvsp[0].exp;;
    break;}
case 77:
#line 239 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new list((sequence *) kifobj::nullmarker);;
    break;}
case 78:
#line 240 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new list(yyvsp[-1].seq);;
    break;}
case 79:
#line 244 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new ukconst(yyvsp[0].val);;
    break;}
case 80:
#line 245 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new ukconst(yyvsp[0].val);;
    break;}
case 81:
#line 246 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new ukconst(yyvsp[0].val);;
    break;}
case 82:
#line 247 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new ukconst(yyvsp[0].val);;
    break;}
case 83:
#line 248 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = yyvsp[0].exp;;
    break;}
case 84:
#line 250 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.seq=new sequence(yyvsp[0].exp);;
    break;}
case 85:
#line 251 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyvsp[-1].seq->add(yyvsp[0].exp);yyval.seq=yyvsp[-1].seq;;
    break;}
case 86:
#line 253 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = yyvsp[0].exp;;
    break;}
case 87:
#line 254 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = yyvsp[0].exp;;
    break;}
case 88:
#line 255 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = yyvsp[0].exp;;
    break;}
case 89:
#line 256 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = yyvsp[0].exp;;
    break;}
case 90:
#line 258 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new defop(yyvsp[0].val);;
    break;}
case 91:
#line 259 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new defop(yyvsp[0].val);;
    break;}
case 92:
#line 260 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new defop(yyvsp[0].val);;
    break;}
case 93:
#line 261 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new defop(yyvsp[0].val);;
    break;}
case 94:
#line 262 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new defop(yyvsp[0].val);;
    break;}
case 95:
#line 263 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new defop(yyvsp[0].val);;
    break;}
case 96:
#line 265 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new termop(yyvsp[0].val);;
    break;}
case 97:
#line 266 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new termop(yyvsp[0].val);;
    break;}
case 98:
#line 267 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new termop(yyvsp[0].val);;
    break;}
case 99:
#line 268 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new termop(yyvsp[0].val);;
    break;}
case 100:
#line 269 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new termop(yyvsp[0].val);;
    break;}
case 101:
#line 270 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new termop(yyvsp[0].val);;
    break;}
case 102:
#line 271 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new termop(yyvsp[0].val);;
    break;}
case 103:
#line 272 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new termop(yyvsp[0].val);;
    break;}
case 104:
#line 273 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new termop(yyvsp[0].val);;
    break;}
case 105:
#line 275 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 106:
#line 276 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 107:
#line 277 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 108:
#line 278 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 109:
#line 279 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 110:
#line 280 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 111:
#line 281 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 112:
#line 282 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 113:
#line 283 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 114:
#line 284 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new sentop(yyvsp[0].val);;
    break;}
case 115:
#line 287 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new ruleop(yyvsp[0].val);;
    break;}
case 116:
#line 288 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new ruleop(yyvsp[0].val);;
    break;}
case 117:
#line 289 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"
{yyval.exp = new ruleop(yyvsp[0].val);;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 291 "/home/src/kqml/C/ver.2/src/lib/kifparse/KIFGrammar.y"


void yyerror(char *s)

{
#ifdef DEBUG
	fprintf( stderr, "%s\n",s );
#endif
}


